/**********************************************************************
 *
 * statusaction.h -- 
 * Copyright (C) 1999  The New Zealand Digital Library Project
 *
 * A component of the Greenstone digital library software
 * from the New Zealand Digital Library Project at the
 * University of Waikato, New Zealand.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: statusaction.h 1279 2000-07-12 22:21:53Z sjboddie $
 *
 *********************************************************************/


#ifndef STATUSACTION_H
#define STATUSACTION_H


#include "gsdlconf.h"
#include "action.h"
#include "receptionist.h"


class statusaction : public action {
protected:
  bool disabled;
  receptionist *recpt;

  void output_frameset (cgiargsclass &args, displayclass &disp, 
			outconvertclass &outconvert, 
			ostream &textout, ostream &logout);

  void output_select (cgiargsclass &args, displayclass &disp, 
		      outconvertclass &outconvert, 
		      ostream &textout, ostream &logout);

  void output_welcome (cgiargsclass &args, recptprotolistclass *protos,
		       displayclass &disp, outconvertclass &outconvert, 
		       ostream &textout, ostream &logout);

  void output_generalinfo (cgiargsclass &args, displayclass &disp, 
			   outconvertclass &outconvert, 
			   ostream &textout, ostream &logout);

  void output_argumentinfo (cgiargsclass &args, displayclass &disp, 
			    outconvertclass &outconvert, 
			    ostream &textout, ostream &logout);

  void output_actioninfo (cgiargsclass &args, displayclass &disp, 
			  outconvertclass &outconvert, 
			  ostream &textout, ostream &logout);

  void output_browserinfo (cgiargsclass &args, displayclass &disp, 
			   outconvertclass &outconvert, 
			   ostream &textout, ostream &logout);

  void output_protocolinfo (cgiargsclass &args, displayclass &disp, 
			    outconvertclass &outconvert, 
			    ostream &textout, ostream &logout);

  void output_collectioninfo (cgiargsclass &args, displayclass &disp, 
			      outconvertclass &outconvert, 
			      ostream &textout, ostream &logout);

  void output_initlog (cgiargsclass &args, displayclass &disp, 
		       outconvertclass &outconvert, 
		       ostream &textout, ostream &logout);

  void output_errorlog (cgiargsclass &args, displayclass &disp, 
			outconvertclass &outconvert, 
			ostream &textout, ostream &logout);

  void output_errorpage (outconvertclass &outconvert, 
			 ostream &textout, ostream &logout,
			 text_t message);

public:
  statusaction ();
  virtual ~statusaction ();

  text_t get_action_name () {return "status";}

  void set_receptionist (receptionist *therecpt) {recpt=therecpt;}

  bool check_cgiargs (cgiargsinfoclass &argsinfo, cgiargsclass &args, 
		      ostream &logout);

  void get_cgihead_info (cgiargsclass &args, recptprotolistclass *protos,
			 response_t &response, text_t &response_data, 
			 ostream &logout);

  bool do_action (cgiargsclass &args, recptprotolistclass *protos, 
		  browsermapclass *browsers, displayclass &disp, 
		  outconvertclass &outconvert, ostream &textout, 
		  ostream &logout);

  void configure (const text_t &key, const text_tarray &cfgline);
};


#endif
